unit frmSelectLevel;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ORCtrls, ExtCtrls, Menus, VA508AccessibilityManager;

type
  TfrmPLevel = class(TForm)
    Panel1: TPanel;
    cboPList: TORComboBox;
    Panel2: TPanel;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    VA508AccessibilityManager1: TVA508AccessibilityManager;
    btnUser: TButton;
    btnTeam: TButton;
    btnService: TButton;
    btnDivision: TButton;
    procedure btnDivisionKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btnDivisionClick(Sender: TObject);
    procedure btnServiceKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btnServiceClick(Sender: TObject);
    procedure btnTeamClick(Sender: TObject);
    procedure btnTeamKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure btnUserKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure btnUserClick(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure cboPListNeedData(Sender: TObject; const StartFrom: String;
      Direction, InsertAt: Integer);
    procedure cboPListDblClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure cboPListKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
    HL : TControl;
    procedure Changelblcolor(C1,C2 : TControl);
  public
    { Public declarations }
    RTNStr : String;
  end;

var
  frmPLevel: TfrmPLevel;

function SelectParLevel():String;
procedure ListService_Section(Dest: TStrings);

implementation

{$R *.DFM}

uses rcore, ORNet, ORfn, frmMain;

function SelectParLevel():String;
var
frmPLevel : TfrmPLevel;
begin
frmPLevel := TfrmPLevel.Create(Application);
frmPLevel.ShowModal;
Result := frmPLevel.RTNStr;
end;

procedure ListService_Section(Dest: TStrings);
{ lists all Service/Section: IEN^Service Name }
begin
  CallV('CRHD LIST SERVICES', [nil]);
  MixedCaseList(RPCBrokerV.Results);
  Dest.Assign(RPCBrokerV.Results);
end;

procedure ListDivisions(Dest: TStrings);
{ lists all Institutions: IEN^Institution Name }
begin
  CallV('CRHD LIST DIVISIONS', [nil]);
  MixedCaseList(RPCBrokerV.Results);
  Dest.Assign(RPCBrokerV.Results);
end;

procedure TfrmPLevel.FormCreate(Sender: TObject);
begin
Font := frmListSelect.Font;
HL := nil;
end;

procedure TfrmPLevel.cboPListNeedData(Sender: TObject;
  const StartFrom: String; Direction, InsertAt: Integer);
begin
if (HL as TButton).tag = 1 then cboPList.ForDataUse(SubSetOfProviders(StartFrom, Direction));
end;

procedure TfrmPLevel.btnDivisionClick(Sender: TObject);
begin
Changelblcolor(HL, btnDivision);
cboPList.Items.Clear;
cboPList.Text := '';
ListDivisions(cboPList.Items);
end;

procedure TfrmPLevel.btnDivisionKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if Key = VK_TAB then btnDivisionClick(btnDivision);
if Key = VK_RETURN then cboPList.SetFocus;
end;

procedure TfrmPLevel.btnServiceClick(Sender: TObject);
begin
Changelblcolor(HL, btnService);
cboPList.Items.Clear;
cboPList.Text := '';
ListService_Section(cboPList.Items);
end;

procedure TfrmPLevel.btnServiceKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if Key = VK_TAB then btnServiceClick(btnService);
if Key = VK_RETURN then cboPList.SetFocus;

end;

procedure TfrmPLevel.btnTeamClick(Sender: TObject);
begin
Changelblcolor(HL, btnTeam);
cboPList.Items.Clear;
cboPList.Text := '';
ListTeamAll(cboPList.Items);
end;

procedure TfrmPLevel.btnTeamKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if Key = VK_TAB then btnTeamClick(btnTeam);
if Key = VK_RETURN then cboPList.SetFocus;
end;

procedure TfrmPLevel.btnUserClick(Sender: TObject);
begin
Changelblcolor(HL, btnUser);
cboPList.Items.Clear;
cboPList.Text := '';

//populate Provider List
with cboPList do
 begin
  ListItemsOnly := true;
  LongList := true;
  InitLongList('');
 end;
end;

procedure TfrmPLevel.btnUserKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if Key = VK_TAB then btnUserClick(btnUser);
if Key = VK_RETURN then cboPList.SetFocus;
end;

procedure TfrmPLevel.cboPListDblClick(Sender: TObject);
begin
if cboPList.itemIndex > -1 then
begin
RTNStr := cboPList.Items[cboPList.itemIndex];

  case (HL as TButton).tag of
   1: RTNStr := RTNStr + '^' + 'USR';   {NEW PERSON 200}
   2: RTNStr := RTNStr + '^' + 'OTL';   {OE/RR TEAM 100.21}
   3: RTNStr := RTNStr + '^' + 'SRV';   {SERVICE -49}{USER 200}
   4: RTNStr := RTNStr + '^' + 'DIV';   {INSTITUTION  4}
   // RTNStr := RTNStr + '^' + 'TS';   {TREATING SPECIALTY 45.7}
   // RTNStr := RTNStr + '^' + 'SD';   {SD TEAM - op teams 404.51}
   // RTNStr := RTNStr + '^' + 'LOC';  {LOCATION 44}
  end;

  Close;
end;
end;

procedure TfrmPLevel.FormShow(Sender: TObject);
begin
HL := btnDivision;
with (HL as TButton)  do
  begin
   SetFocus;
   OnClick(Sender);
  end;
end;

procedure TfrmPLevel.cboPListKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
If Key = VK_RETURN then cboPListDblClick(cboPList);
end;

procedure TfrmPLevel.Changelblcolor(C1, C2: TControl);
begin
    HL := (C2 as TButton);
end;     

procedure TfrmPLevel.Exit1Click(Sender: TObject);
begin
Close;
end;

end.
