unit frmTeamI;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus, ComCtrls, VA508AccessibilityManager;

type
  TfrmTeamInfo = class(TForm)
    PopupMenu1: TPopupMenu;
    Print1: TMenuItem;
    Memo1: TRichEdit;
    Save1: TMenuItem;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    VA508AccessibilityManager1: TVA508AccessibilityManager;
    procedure Exit1Click(Sender: TObject);
    procedure Print1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    TeamName : String;
    TeamMgr : String;
    FileOpened : String;
  public
    { Public declarations }
  end;

var
  frmTeamInfo: TfrmTeamInfo;

procedure DisplayFile(TM:String);

implementation

uses frmMain, frmTeamRoster, Orfn, OrNet, Util;

{$R *.DFM}



procedure DisplayFile(TM : String);
var
frmTeamInfo : TfrmTeamInfo ;
fileName : String;
tf, tf2 : String;
filePath : String;
vp, vs : String;
begin
  frmTeamInfo := TfrmTeamInfo.Create(frmListSelect);
try
  tf2 := '';
  tf := '';

  if TM = '' then TM := frmListSelect.DUZ + '^USR';
  frmTeamInfo.TeamName := TM;

  if frmListSelect.UserPar.FILE_Location <> '' then filePath := frmListSelect.UserPar.FILE_Location;

  filename := sCallV('CRHD GET TEAM FILENAME', [TM]);

  if filename = '' then filename :=  piece(TM,'^',2) + '.Txt';

   filename := piece(filename,'.',1) + '.txt';
  vp := ExtractFilePath(filename);
  vs := ExtractFileName(filename);

  if vp <>  '' then filepath := vp;

  if filePath <> '' then
   tf := IncludeTrailingPathDelimiter(filepath) + vs;

  if Not FileExists(tf) then
   begin
   tf2 := tf;
    tf := IncludeTrailingPathDelimiter(GetCurrentDir) + filename;
    if FileExists(tf) then filename := tf
    else filename := '';
   end
  else filename := tf;

  if fileName <> '' then
       with frmTeamInfo do
        begin
        Memo1.Clear;
        Memo1.Hint := 'File Last Edit: ' + GetFileAge(fileName);
        Memo1.Lines.LoadFromFile(fileName);
        Memo1.ReadOnly := True;
        FileOpened := fileName;
        frmTeamInfo.ShowModal;
        end
      else
        begin
          ShowMessage('File not found');
        end;
finally
 frmTeamInfo.Free;
end;
end;


procedure TfrmTeamInfo.Print1Click(Sender: TObject);
var
str : string;
begin
str := GetDefaultPrinterName ;
if str <> '' then
 if (FileOpened <> '') and FileExists(FileOpened) then  Memo1.Print(FileOpened)
 else
ShowMessage('Problem printing to default printer');
end;

procedure TfrmTeamInfo.Save1Click(Sender: TObject);
begin
if pos('1',TeamMgr)>0 then
if (FileOpened<> '') and FileExists(FileOpened) then
  Memo1.Lines.SaveToFile(FileOpened)
else
  ShowMessage('Only Team Managers can save data');
end;

procedure TfrmTeamInfo.Exit1Click(Sender: TObject);
begin
Close;
end;

procedure TfrmTeamInfo.FormActivate(Sender: TObject);
var
Mi : TMenuItem;
begin
 TeamMgr := sCallV('CRHD HOT CAN EDIT',[TeamName , frmListSelect.DUZ]) ;
 if pos('1',TeamMgr)>0 then
 begin
 Mi := PopupMenu1.Items.Find('Save');
 if Mi <> nil then
  begin
   Mi.Enabled := True;
   Memo1.ReadOnly := False;
  end;
 end;
end;

procedure TfrmTeamInfo.FormCreate(Sender: TObject);
begin
Font := frmListSelect.Font;
end;

end.
